diff --git a/.gitignore b/.gitignore
index 7e9932e..2601543 100644
--- a/.gitignore
+++ b/.gitignore
@@ -9,6 +9,7 @@
 #
 # Normal rules
 #
+source
 .*
 *.o
 *.o.*
diff --git a/scripts/package/builddeb b/scripts/package/builddeb
index 90e521f..b50b01e 100644
--- a/scripts/package/builddeb
+++ b/scripts/package/builddeb
@@ -207,6 +207,12 @@ else
 fi
 maintainer="$name <$email>"
 
+mkdir -p debian/source
+# Generate a source format template
+cat <<EOF > debian/source/format
+3.0 (git)
+EOF
+
 # Generate a simple changelog template
 cat <<EOF > debian/changelog
 linux-upstream ($packageversion) unstable; urgency=low
@@ -294,7 +300,7 @@ cat <<EOF >> debian/control
 
 Package: $kernel_headers_packagename
 Provides: linux-headers, linux-headers-2.6
-Architecture: $arch
+Architecture: any
 Description: Linux kernel headers for $KERNELRELEASE on $arch
  This package provides kernel header files for $KERNELRELEASE on $arch
  .
@@ -309,7 +315,7 @@ if [ -e "$tmpdir/lib/firmware" ]; then
 	cat <<EOF >> debian/control
 
 Package: $fwpackagename
-Architecture: all
+Architecture: any
 Description: Linux kernel firmware, version $version
  This package contains firmware from the Linux kernel, version $version.
 EOF
@@ -361,4 +367,24 @@ EOF
 	create_package "$dbg_packagename" "$dbg_dir"
 fi
 
+# create source package
+cp -a debian source
+if [ ! -x source/.config ] ; then
+	cp .config source/
+fi
+
+cd source
+git add -f debian .config
+git commit -sam "add current kernel config and debian directory"
+dpkg-source -b .
+
+if [ -x source ] ; then
+	cp .config config
+fi
+git reset --hard HEAD~1
+
+if [ -x source ] ; then
+	mv config .config
+fi
+
 exit 0
